/**
 * Designed and developed by Andrea Cioccarelli (@cioccarellia)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.cioccarellia.kite.internal

import android.content.Context
import com.cioccarellia.kite.Kite
import com.cioccarellia.kite.fetchers.KiteFetcher

@PublishedApi
internal inline fun <T : KiteFetcher> T.switchContext(
    targetContext: Context,
    lambda: (T) -> Unit
): T = apply {
    val initialContext = Kite.context
    Kite.context = targetContext
    lambda(this)
    Kite.context = initialContext
}